:- module(tiny, []).
:- use_module(pac('expand-pac')).
term_expansion --> expand_pac.
:- include(pac(op).

:- op(10, fx, *).
%
parse(X, Y):- term_string(X, Y).

%
% ?- use_module(pac(tiny)).
% Peano arithmetic.
% ?- tiny:peano(1+2*3, R).
% ?- tiny:peano((1+2*3)^2, R).
% ?- tiny:peano(10^5, R).

% ?- listing(tiny:peano).
:- bekind(peano, []).
N			= `N	:- integer(N), N >= 0.
A +  B		=  add_ @ A @ B.
A *  B		=  mul_ @ A @ B.
A ^  B		=  pow_ @ B @ A.
pred_(0)	= `0.
pred_(I)	= xargs(succ) @ I.
add_(0, A)	= `A.
add_(I, A)	= add_ @ pred_(I) @ :succ(A).
mul_(0, _)	= `0.
mul_(I, A)	= add_(A) @ (mul_ @ pred_(I) @ A).
pow_(0, _)	= `1.
pow_(I, A)	= mul_(A) @ (pow_ @ pred_(I) @ A).
:- ekind.

%
predicate_arity(F, L):-
	setof(P/N,
		A^X^(	predicate_property(A:X, file(F)),
			functor(X, P, N)
		  ),
	      L).
