:- module('$pac$', []).
:- user:set_prolog_flag(encoding, utf8).
:- user:set_prolog_flag(optimise, true).
:- user:set_prolog_flag(qcompile, auto).
:- user:set_prolog_flag(editor, emacsclient).
:- user:set_prolog_flag(history, 0).
:- setenv('EDITOR', emacsclient).

:- dynamic user:file_search_path/2.
:- multifile user:file_search_path/2.

:- use_module('setup-aux').

pac_directories(
		[	(pac_root : []) -
			 [	test:test,
				:(prolog) -
					[	pac		: pac,
						util	: util,
						zdd		: zdd,
						tmp		: tmp,
						gb		: "util/grobner",
						other	: other
					]]]
			   ).

setup_root_home_user(Dir):-
	split_string(Dir, /, '',  [_, Root, User|_]),
	atomic_list_concat([/,Root,/,User], Home),
	setenv(home, Home),
	setenv(user, User),
	setenv(pac_root, Dir).

setup_cgi_config:-  getenv(home, H),
	atom_concat(H, '/.config/cgi-config', Mod),
	use_module(Mod),
	cgi_eqns(Eqns),
	maplist(setup_env, Eqns),
	pac_directories(DirStr),
	mk_file_search_path(DirStr).

:- prolog_load_context(directory, Dir),
	setup_root_home_user(Dir),
	setup_cgi_config.

% ?- getenv(user, U), getenv(home, H), getenv(host_user, HU).
% :- pac_directories(DirStr),
% 	mk_file_search_path(DirStr).

% :- set_prolog_flag(color_term, false).
% :- set_stream(user_input, tty(true)).
% :- set_prolog_flag(tty_control, false).

user: enable_pac_query	:- set_prolog_flag(pac, true).
user: disable_pac_query	:- set_prolog_flag(pac, false).
user: chk_pac_query	:- current_prolog_flag(pac, true).

user: enable_odict	:- set_prolog_flag(odict, true).
user: disable_odict	:- set_prolog_flag(odict, false).
user: chk_odict		:- current_prolog_flag(odict, true).

:- use_module([
		library(clpfd),
		library(dif),
		library(lists),
		library(sort),
		library(ordsets),
		library(url),
		library(ugraphs),
		library(readutil),
		library(apply),
   		library(apply_macros)
	      ]).
%
user: expand_query(X, Y, Z, Z) :- user:chk_pac_query, !,
	'$current_typein_module'(C),
	pac:expand_query(C, X, Y).
user: expand_query(X, X, Z, Z).

:- use_module(pac('expand-pac')).
:- use_module(util('env-dict')).
:- use_module(util(file)).

:- user:enable_pac_query.
:- user:enable_odict.
