:- module(beta,
	  [beta_subst/3, normal_form/2,
	  fresh_bind/2, fresh_goal/3, fresh_call/2
	   ]).

:- use_module(pac(basic)).
:- use_module(pac(reduce)).
:- use_module(util('emacs-handler')).
:- use_module(pac(op)).
:- use_module(pac(meta)).

		/********************************************************
		*     Note: This very old codes is currently broken.    *
		*     No plan to review and rewrite.                    *
		********************************************************/


        /********************************
		*     Lambda-beta conversion    *
		********************************/

% ?- qcompile(util(beta)).
% ?- module(beta).

% ?- beta:normal_form(f((x\x)@a, (y\y)@b), X).
%@ X = f(a, b).
% ?- beta_one(f(x\x@a, y\y@b), X).
% X = f(a, y\y@b)
% ?- beta((x\x)@a, X).
% X = a.

normal_form(X, Y):-  beta_one(X, X0), !,
	normal_form(X0, Y).
normal_form(X, X).

beta(E, M0):- is_beta_redex(E),
	E = @(\(X, M), N),
	fresh_bind(\(X,M), \(X0,M0)),
	X0 = N.
%
is_beta_redex(M):- nonvar(M), M=(F@_), nonvar(F), F=(_\_).

%
beta_one(M, M0):- beta(M, M0).
beta_one(X, Y):- compound(X), X=..[F|Xs],
	beta_one_list(Xs, Ys),
	Y=..[F|Ys].
%
beta_one_list([X|Xs], [Y|Xs]):- beta_one(X, Y).
beta_one_list([X|Xs], [X|Ys]):- beta_one_list(Xs, Ys).

%%%
outer_most_first(X, Y):- var(X), !, Y=X.
outer_most_first(F@A, Y):- !, outer_most_first(A, A0),
	outer_most_first(F, F0),
	beta_outer_most_first(F0, A0, Y).
outer_most_first(X, X).

%
beta_outer_most_first(F, A, F@A):- var(F), !.
beta_outer_most_first(X\M, A, Y):- !, fresh_bind(X\M, X0\Y), X0=A.
% beta_outer_most_first(X\M, A, Y):- !, fresh_bind(X\M, X0\Y0), X0=A,
%	outer_most_first(Y0, Y).
beta_outer_most_first(F, A, F@A).

% ?- church(ycombinator @ factorial@ cn(2), X).
% ?- church(ycombinator @ factorial@ cn(3), X), numbervars(X, 0, _), write_canonical(X).
% ?- macro_expansion(if(true, succ(zero), one), X).
% X = (x\y\z\ (x@y@z)@f\x\ (f@x)@ (n\f\x\ (f@ (n@f@x))@f\x\x)@x\y\x).

% church(X, Y):- macro_expansion(X, X0), normal_form(X0, Y).

% church_outer_most(X, Y):- macro_expansion(X, X0),
%	outer_most_first(X0, Y).

lambda_application(E, [], E).
lambda_application(E, [A|As], E0):- lambda_application(E@A, As, E0).

%%%%  Yet Another deBrujin-ing

% ?- qcompile(util(beta)).
% ?- module(beta).
% ?- fresh_bind([x,x]\a(x,x), P), numbervars(P, 0, _).
% ?- fresh_bind(x\a(x,x), P), numbervars(P, 0, _).
% ?- fresh_bind([x,x]\a(x,x), P), numbervars(P, 0, _).
% ?- fresh_bind([x,x]\a(x,x), P), numbervars(P, 0, _).

:- meta_predicate fresh_bind(6, ?, ?).

fresh_bind(T0, T) :- fresh_bind(protected, T0, T).
%
fresh_bind(P, T0, T) :- fresh_bind(P, [], T0, T).

%
fresh_bind(_, Assoc, X, Y):- (var(X); atom(X)), !,
	(assocq(Assoc, X, Y) -> true;  Y = X).
fresh_bind(P, Assoc, X, X0):- call(P, X, V, B, X0, V0, B0), !,
	fresh_vars(P, V, V0, Assoc, Assoc0),
	fresh_bind(P, Assoc0, B, B0).
fresh_bind(P, Assoc, X, Y):- mapterm_rec(beta:fresh_bind(P, Assoc), X, Y).

%
fresh_vars(P, V, V0, Assoc, Assoc0):-
	(	(var(V); atom(V))
	->	Assoc0 = [(V,V0)|Assoc]
	;	fresh_bind_(V, V0, Assoc, Assoc0, P)
	).

fresh_bind_(X, Y, Assoc, Assoc0, P):- var(X), !,
	fresh_bind_([X], Y, Assoc, Assoc0, P).
fresh_bind_([], [], Assoc, Assoc, _):- !.
fresh_bind_([X|Y], [X0|Y0], Assoc, Assoc0, P):-!,
	fresh_bind_(Y, Y0, [(X,X0)|Assoc], Assoc0, P).
fresh_bind_(X, Y, Assoc, Assoc0, P):-
	fresh_bind_([X], Y, Assoc, Assoc0, P).

%
copy_term(X, B, C):- copy_term((X,B), (Y,C)), X=Y.
%
protected(st(E, V, B), V, a(B, E), st(E0, V0, B0), V0, a(B0, E0)).
protected(#(E, V, B), V, a(B, E), #(E0, V0, B0), V0, a(B0, E0)).
protected(^(V, B), V, B, ^(V0, B0), V0, B0).
protected(\(V,B), V, B, \(V0,B0), V0, B0).
protected(\\(V,B), V, B, \\(V0,B0), V0, B0).
protected(forall(V, B), V, B, forall(V0, B0), V0, B0).
protected(exists(V, B), V, B, exists(V0, B0), V0, B0).
protected(every(V, B), V, B, every(V0, B0), V0, B0).
protected(some(V, B), V, B, some(V0, B0), V0, B0).

%%%% test alpha equivalence between closed terms.
% ?- alpha_equiv(x\x@(x\x), y\y@(z\z)).

alpha_equiv(X,Y):- fresh_bind(X, X0), fresh_bind(Y, Y0),
	numbervars(X0, 0, N), numbervars(Y0, 0, N),
	X0==Y0.

% ?- qcompile(util(beta)).
% ?- module(beta).

% Beta conversion for Lambda Calculus.
% ?- beta_star((x\x)@a, X).
% ?- var_beta_star((_x\_x)@a, X).
% ?- beta_star((x\forall(x,x=x))@a, X).
% ?- var_beta_star((x\forall(x,x=x))@a, X).

beta_star(X, Y):- reduce:term_rewrite(beta:beta_star_, [], X, Y).

beta_star_(X, _):- var(X), !, fail.
beta_star_(@(\(X,Y), Z), Y0):- fresh_bind(\(X,Y), \(X0, Y0)), X0=Z.

var_beta_star(X, Y):- reduce:term_rewrite(beta:beta_star_, [], X, Y).

var_beta_star_(X, _):- var(X), !, fail.
var_beta_star_(@(\(X,Y), Z), U):- beta_subst([(X,Z)], Y, U).

%%%%
% Not obsolete ! ;  used by ptq module
beta_subst(X, Y, Z):- once(beta_subst([], X, Y, Z)).

beta_subst(Vs, _, A, A) :- memq(A, Vs).
beta_subst(_, Ps, A, B) :- assocq(Ps, A, B).
beta_subst(_, Ps, A, A) :- (Ps==[]; var(A)).
beta_subst(Vs, Ps, \(X,A), \(X,B)) :- beta_subst([X|Vs], Ps, A, B).
beta_subst(Vs, Ps, A, B) :-
	atomic(A) -> B=A ; mapterm_rec(beta:beta_subst(Vs, Ps), A, B).

% fresh_goal/3
% ?- qcompile(util(beta)).
% ?- module(beta).

% ?- fresh_goal([X]:-a(X), A, G).
fresh_goal(H:-G, A, G0):- !, fresh_goal(H, G, A, G0).
fresh_goal(:-G, [], G0):- !, copy_term(G, G0).
fresh_goal(^(F, X), A, true):- !, copy_term((F, X), (F, A)).
fresh_goal(fix(X, E), A, G):- !, fresh_goal_fix(X, E, A, G).
fresh_goal([],[], true):-!.
fresh_goal([A|B], C, true):-!, copy_term([A|B],C).

% fresh_goal/4
fresh_goal(H, G, A, G0):- var(H), !, copy_term((H, G), (A, G0)).
fresh_goal(F^X, G, A, G0):- !, copy_term((F, X, G), (F, A, G0)).
fresh_goal(^(F), G, [], G0):- !, copy_term((F, G), (F, G0)).
fresh_goal(X, G, A, G0):- copy_term((X, G), (A, G0)).

fresh_goal_fix(X, E, A, app(E0, A)):- var(X), !,
	copy_term(fix(X, E), fix(X0, E0)),
	X0 = fix(X,E).
fresh_goal_fix(V^X, E, A, app(E0, A)):- !,
	copy_term(fix(V, X, E), fix(V, X0, E0)),
	X0 = fix(V^X,E).

%
%
fresh_call(X, A):- fresh_bind(X\A, _\A0), call(A0).
