:- module(infomath,[]).
% :- [pac(infomath)].

random_point(X, Y):- X is random_float,
	Y is random_float.

pi(N, Pi):- monte_carlo(N, 0, In),
	Pi is 4.0* (In / N).

monte_carlo(0, In, In).
monte_carlo(N, In, In1):- N > 0,
	N0 is N-1,
	random_point(X,Y),
	(	X^2 + Y^2 < 1
	->	In0 is In+1
	;	In0 = In
	),
	monte_carlo(N0, In0, In1).

% pi/4 : 1 =  X : N.   pi = 4*X/N

% ?- infomath:pi(10000000, Pi).
%@ Pi = 3.1415876 .













