:- module(tm, []).
:- use_module(pac(basic)).
:- use_module(util(meta2)).
:- use_module(pac('expand-pac')).
term_expansion --> pac:expand_pac.
:- use_module(pac(op)).


% ?- cpr handle works.
% ?- listing(set).
% ?- set(pow([1,2,3])\pow([2,3]), X).
% ?- set(pow(pow([1,2,3])), X), length(X, L).
% ?- set(X, V).

% ?- listing(set).
% ?- set(yaplus([a,b], [c,d]), R).
% ?- set(plus([a,b], [c,d]), R).
% ?- set(yayaplus([a,b], [c,d]), R).

% ?- listing(set).
:- bekind(set, [nonvar, stop]).
sgn(emptyset, 0, []).
sgn([], 0,	[]).
sgn([X|Y], 0, [X|Y]).
sgn(+, 2,	union).
sgn(plus, 2, pred([X, Y, Z]:-union(X, Y, Z))).
sgn(yaplus, 2, fun([X, Y]>> :union(X, Y))).
sgn(yayaplus, 2, fun([X, Y]>> :union@X@Y)).
sgn(&, 2,	intersection).
sgn(\, 2,	subtract).
sgn(pow, 1, powerset).
sgn(++, 2,	direct_sum).
sgn(*, 2,	product).
sgn(#, 2,	scramble_cons).
singleton(A) = xargs([X] >> [X])@ A.
:- ekind.

% :- bekind(yaset, [nonvar, stop, flip([2,1])]).
:- bekind(yaset, [nonvar, stop]).
emptyset = [].
X = `X :- is_list(X), !.
singleton(A) = xargs([X] >> [X])@ A.
+(A, B)	= :union@A@B.
&(A, B) = :intersection @ A @ B.
\(A, B) = :subtract@ A @ B.
pow(A)	= :powerset@ A.
++(A, B) = :direct_sum @ A @ B.
*(A, B) = :product @ A @ B.
#(A, B) = :scramble_cons @ A@ B.
:- ekind.
