:- module(primrec, []).
:- dynamic  def/2.
:- use_module(pac(op)).

def(%%  階乗関数の原始帰納的定義
   fact(0) =1;
   fact(s(n)) = s(n) * fact(n);

   0 * x = 0;
   s(n)* x =  x + n * x;

   0 + x = x;
   s(n) + x  = s(n + x);

%%% 素数判定関数用

   decr(0) = 0;
   decr(s(x)) = x;

  (m - 0) = m;
  (m - s(n)) = decr(m- n);

   zero(0)=1;
   zero(s(x))=0;

   not(0) = 1;
   not(s(n)) = 0;

   &(0, x) = 0;
   &(s(n), x) = not(zero(x));

   or(x, y) =  not(&(not(x), not(y)));

   if(0, x, y) = y;
   if(s(n), x, y) = x;

   positive(0) = 0;
   positive(s(x)) = 1;

   (x > y) = positive(x - y);

   (x=y) = &(zero(x-y), zero(y-x));

   mod_aux(m, r) = if(m-r>1, r+1, 0);

   mod(0, m) = 0;
   mod(s(x), m) =  mod_aux(m, mod(x, m));

   prime(x) = &(x>1, not(exists_proper_divisor(x, x)));

   has_a_factor(0, y) = 0;
   has_a_factor(s(x), y) =  &(x>1, or(mod(y,x)=0, has_a_factor(x, y)))).


pr_eval(X, Y):- integer(X), !, X >= 0, int_numeral(X, Y).
pr_eval(T, V):- mapterm(pr_eval, T, T0), pr_apply(T0, V).

pr_apply(X, Y):- def(X, Body), !, pr_eval(Body, Y).
pr_apply(X, X).

int_numeral(0, 0):-!.
int_numeral(X, s(Y)) :- X1 is X-1, int_numeral(X1, Y).

numeral_int(0, 0).
numeral_int(s(X), Y):- numeral_int(X, X0), Y is X0+1.

pr(Query, V=V0):- abolish(def/2),
	def(Eqs),
	assert_pr(def, Eqs),
	pr_eval(Query, V0),
	numeral_int(V0, V).

pr_eval_demo(Eqs, Query, V=V0):- abolish(def/2),
	assert_pr(def, Eqs),
	pr_eval(Query, V0),
	numeral_int(V0, V).

assert_pr(D, A; B):- !, assert_pr(D, A), assert_pr(D, B).
assert_pr(D, A = B):- subst_var(A=B, A0=B0),
	C =.. [D, A0, B0],
	assert(C).
