:- module(tex_symbol, []).
:- encoding(utf8).

logical_connective(to, (-->)).
logical_connective(to, (->)).
logical_connective(forall, all).
logical_connective(forall, forall).
logical_connective(forall, every).
logical_connective(exists, some).
logical_connective(exists, exists).
logical_connective(land, '*').
logical_connective(land, ',').
logical_connective(lor, ';').
logical_connective(lor, '+').
logical_connective(iff, '<-->').
logical_connective(iff, '<->').
logical_connective(iff, '<==>').
logical_connective(iff, '<=>').
logical_connective(equiv, '<-->').
logical_connective(equiv, '<->').
logical_connective(vdash, '|-').
logical_connective(mid, ('|')).
logical_connective(neg, ('-')).
logical_connective(neg, ('~')).


% %%
% ts_atom(in, '∈').
% ts_atom(subseteq, '⊆').
% ts_atom(neg, '¬').
% ts_atom(ne, '≠').
% ts_atom(not, '¬').
% ts_atom(alpha, 'α').
% ts_atom(beta, 'β').
% ts_atom(sigma, 'σ').
% ts_atom('Sigma', 'Σ').
% ts_atom(cup, '∪').
% ts_atom(cap, '∩').
% ts_atom('Gamma', 'Γ').
% ts_atom(gamma, 'γ').
% ts_atom('Psi', 'Ψ').
% ts_atom(psi, 'ψ').
% ts_atom('Omega', 'Ω').
% ts_atom(omega, 'ω').
% ts_atom('Delta', 'Δ').
% ts_atom(delta, 'δ').
% ts_atom(varepsilon, 'ε').
% ts_atom(emptyset, 'φ').
% ts_atom('Phi', 'Φ').
% ts_atom(phi, φ).
% ts_atom('Lambda', 'Λ').
% ts_atom(lambda, 'λ').
% ts_atom('Pi', 'Π').
% ts_atom(pi, 'π').
% ts_atom(iota, 'ι').
% ts_atom(eta, 'η').
% ts_atom(kappa, 'κ').
% ts_atom(sim, '〜').
% ts_atom(times, '×').
% ts_atom('To', '⇒').
% ts_atom(to, '→').
% ts_atom(to, (-->)).
% ts_atom(to, (->)).
% ts_atom(forall, '∀').
% ts_atom(exists, '∃').
% ts_atom(land, '∧').
% ts_atom(lor, '∨').
% ts_atom(iff, '⇔').
% ts_atom(equiv, '≡').
% ts_atom(vdash, '|-').
% ts_atom(mid, ('|')).
% ts_atom(bot, '⊥').
% ts_atom(xi, 'ξ').
% ts_atom('Xi', 'Ξ').
% ts_atom(because, '∵').
% ts_atom(therefore, '∴').
% ts_atom(aleph, 'ℵ').
% ts_atom(otimes, '⊗').
% ts_atom(oplus, '⊕').
% ts_atom(infty, '∞').
% ts_atom(cong, '≅').
% ts_atom(simeq, '≃').
% ts_atom(partial, '∂').


% %%%%%
% punct("．") --> "。".
% punct("，") --> "、".
% punct(" ") --> "　".

% %%%%%%
% punct_opp("。") --> "．".
% punct_opp("、") --> "，".

% %%%%%%
% dcg_st("\\in") --> "∈".
% dcg_st("\\subseteq") --> "⊆".
% dcg_st("\\neg") --> "¬".
% dcg_st("\\neg") --> "¬".
% dcg_st("\\ne") --> "≠".
% dcg_st("\\alpha") --> "α".
% dcg_st("\\beta") --> "β".
% dcg_st("\\sigma") --> "σ".
% dcg_st("\\Sigma") --> "Σ".
% dcg_st("\\cup") --> "∪".
% dcg_st("\\cap") --> "∩".
% dcg_st("\\Gamma") --> "Γ".
% dcg_st("\\gamma") --> "γ".
% dcg_st("\\Psi") --> "Ψ".
% dcg_st("\\psi") --> "ψ".
% dcg_st("\\Omega") --> "Ω".
% dcg_st("\\omega") --> "ω".
% dcg_st("\\Delta") --> "Δ".
% dcg_st("\\delta") --> "δ".
% dcg_st("\\varepsilon") --> "ε".
% dcg_st("\\emptyset") --> "φ".
% dcg_st("\\Phi") --> "Φ".
% dcg_st("\\phi") --> "φ".
% dcg_st("\\Lambda") --> "Λ".
% dcg_st("\\lambda") --> "λ".
% dcg_st("\\Pi") --> "Π".
% dcg_st("\\pi") --> "π".
% dcg_st("\\iota") --> "ι".
% dcg_st("\\eta") --> "η".
% dcg_st("\\kappa") --> "κ".
% dcg_st("\\sim") --> "〜".
% dcg_st("\\times") --> "×".
% dcg_st("\\To") --> "⇒".
% dcg_st("\\to") --> "→".
% dcg_st("\\to") --> "-->".
% dcg_st("\\to") --> "->".
% dcg_st("\\forall") --> "∀".
% dcg_st("\\exists") --> "∃".
% dcg_st("\\land") --> "∧".
% dcg_st("\\lor") --> "∨".
% dcg_st("\\iff") --> "⇔".
% dcg_st("\\equiv") --> "≡".
% dcg_st("\\vdash") --> "|-".
% dcg_st("\\mid") --> "|".
% dcg_st("\\bot") --> "⊥".
% dcg_st("\\because") --> "∵".
% dcg_st("\\aleph") --> "ℵ".
% dcg_st("\\partial") --> "∂".
% dcg_st("\\xi") --> "ξ".
% dcg_st("\\Xi") --> "Ξ".

% %%%%%%%%%% TeX ==> Japanese Kanji
% dcg_ts("∵") --> "\\because".
% dcg_ts("∈") --> "\\in".
% dcg_ts("⊆") --> "\\subseteq".
% dcg_ts("¬") --> "\\neg".
% dcg_ts("¬") --> "\\not".
% dcg_ts("≠") --> "\\ne".
% dcg_ts("α") --> "\\alpha".
% dcg_ts("β") --> "\\beta".
% dcg_ts("σ") --> "\\sigma".
% dcg_ts("Σ") --> "\\Sigma".
% dcg_ts("∪") --> "\\cup".
% dcg_ts("∩") --> "\\cap".
% dcg_ts("Γ") --> "\\Gamma".
% dcg_ts("γ") --> "\\gamma".
% dcg_ts("Ψ") --> "\\Psi".
% dcg_ts("ψ") --> "\\psi".
% dcg_ts("Ω") --> "\\Omega".
% dcg_ts("ω") --> "\\omega".
% dcg_ts("Δ") --> "\\Delta".
% dcg_ts("δ") --> "\\delta".
% dcg_ts("ε") --> "\\varepsilon".
% dcg_ts("φ") --> "\\emptyset".
% dcg_ts("Φ") --> "\\Phi".
% dcg_ts("φ") --> "\\phi".
% dcg_ts("Λ") --> "\\Lambda".
% dcg_ts("λ") --> "\\lambda".
% dcg_ts("Π") --> "\\Pi".
% dcg_ts("π") --> "\\pi".
% dcg_ts("ι") --> "\\iota".
% dcg_ts("η") --> "\\eta".
% dcg_ts("κ") --> "\\kappa".
% dcg_ts("〜") --> "\\sim".
% dcg_ts("×") --> "\\times".
% dcg_ts("→") --> "\\to".
% dcg_ts("-->") --> "\\to".
% dcg_ts("->") --> "\\to".
% dcg_ts("∀") --> "\\forall".
% dcg_ts("∃") --> "\\exists".
% dcg_ts("∧") --> "\\land".
% dcg_ts("∨") --> "\\lor".
% dcg_ts("⇔") --> "\\iff".
% dcg_ts("⇒") --> "\\To".
% dcg_ts("≡") --> "\\equiv".
% dcg_ts("|-") --> "\\vdash".
% dcg_ts("|") --> "\\mid".
% dcg_ts("⊥") --> "\\bot".
% dcg_ts("ℵ") --> "\\aleph".
% dcg_ts("∂") --> "\\partial".
% dcg_ts("≃") --> "\\simeq".
% dcg_ts("≅") --> "\\cong".
% dcg_ts("ξ")--> "\\xi".
% dcg_ts("Ξ")--> "\\Xi".
