:- module(w, []).

% :- use_module(engine).
:- use_module(util('swap-args')).
% :- expects_dialect(pac).
term_expansion --> pac:expand_pac.
% term_expansion -->  expand_pac.
:- use_module(pac(op)).
:- style_check(-singleton).

% ?- w:swap_args_of(f, 1, 2,` f([], [])`, X), smash(X).
% ?- w:swap_args_of(f, 1, 2,` f([a,b], [[]])`, X), smash(X).
% ?- w:swap_args_of(f, 1, 2,`f(a, g(b))`, X), smash(X).
% ?- w:swap_args_of(f, 1, 2,`f([], [])`, X), smash(X).
% ?- w:swap_args_of(f, 2, 3,`f(a, b, c)`, X), smash(X).
% ?- w:swap_args_of(f, 2, 3,`f(a, b, c) + x`, X), smash(X).
% ?- w:swap_args_of(f, 2, 3,` f(a, b, c, d`, X), smash(X).


% ?- w:easy_arith(1 + 0, X).
%@ X = 1 .
%@ X = 1 .
% ?- w:easy_arith(pred(0), X).
%@ X = pred(0).
%@ X = 0 .
% ?- w:easy_arith(2 + 2, X).
% ?- w:easy_arith(2 * 2, X).
%@ X = 4 .
% ?- w:easy_arith(2 + 2 * 3, X).
%@ X = 8 .
% ?- w:easy_arith((1+ 1) + ((2 + 1) + 3), X).
%@ X = 8 .
%@ X = 8 .
%@ X = 8
% ?- trace, w:easy_arith(add(2,1), X).
%@ X = 5 .



int_mul(predec(0),0):-! .
int_mul(predec(N),A1):-succ(N0,N),!,int_mul(N0,A1) .
int_mul(X+Y,A1):-!,(int_mul(X,A2),int_mul(Y,A3)),int_mul(add(A2,A3),A1) .
int_mul(add(N,0),A1):-!,int_mul(N,A1) .
int_mul(add(A,B),A1):-!,(int_mul(predec(B),A2),int_mul(add(A,A2),A3)),succ(A3,A1) .
int_mul(A*B,A1):-!,(int_mul(A,A2),int_mul(B,A3)),int_mul(mul(A2,A3),A1) .
int_mul(mul(A1,0),0):-! .
int_mul(mul(A,N),A1):-!,((int_mul(predec(N),A2),int_mul(mul(A,A2),A3)),int_mul(A,A4)),int_mul(A3+A4,A1) .
int_mul(N,N):-! .


% ?- listing(w:easy_arith).
%@ easy_arith(predec(0), 0).
%@ easy_arith(predec(A), C) :-
%@ 	succ(B, A),
%@ 	easy_arith(B, C).
%@ easy_arith(A+B, E) :-
%@ 	easy_arith(A, C),
%@ 	easy_arith(B, D),
%@ 	easy_arith(add(C, D), E).
%@ easy_arith(add(A, 0), B) :-
%@ 	easy_arith(A, B).
%@ easy_arith(add(B, A), E) :-
%@ 	easy_arith(predec(A), C),
%@ 	easy_arith(add(B, C), D),
%@ 	succ(D, E).
%@ easy_arith(A*B, E) :-
%@ 	easy_arith(A, C),
%@ 	easy_arith(B, D),
%@ 	easy_arith(mul(C, D), E).
%@ easy_arith(mul(_, 0), 0).
%@ easy_arith(mul(B, A), F) :-
%@ 	easy_arith(predec(A), C),
%@ 	easy_arith(mul(B, C), D),
%@ 	easy_arith(B, E),
%@ 	easy_arith(D+E, F).
%@ easy_arith(A, A).
%@
%@ true.
