:- module(zdd_gv, [arrows/1]).
:- use_module(library(lists)).
:- use_module(util(misc)).
:- use_module(zdd('emacs-handler')).
:- use_module(util(file)).

% ?-  use_module(util('zdd-graphviz')).
% ?- zdd_gv:arrows([(a(1), +, true(2)), (3, -, false), (5, -, 6), (7, +, 8), (9, -, 10)]).

arrows(Arrows):-arrowviz_jpg(arrows2dot, Arrows).
%
arrowviz(Pred, Aut):-
	absolute_file_name(pac_tmp('DOTTEMP.dot'), DOT),
	absolute_file_name(pac_tmp('DOTTEMP.'), M),
	file(DOT, write, call(Pred, Aut)),
	eh:sh(dot(-'T'(ps2), -o(M+ps), M+dot);
			ps2pdf(M+ps, M+pdf);
			open(-a('Preview'), M+pdf)).
%
arrowviz_jpg(Pred, Aut):-
	absolute_file_name(pac_tmp('DOTTEMP.dot'), DOT),
	absolute_file_name(pac_tmp('DOTTEMP.'), M),
	file(DOT, write, call(Pred, Aut)),
	eh:sh(dot(-'T'(jpg), -o(M+jpg), M+dot)
		   ; open(-a('Preview'), M+jpg)).

%
arrows2dot(Arrows):-
     format("digraph g {~n",[]),
     format("rankdir=LR;~n",[]),
     format("dummy [shape = none, label = \"\"];~n",[]),
     move_in_dot(Arrows),
     format("}~n",[]).
%
move_in_dot([]).
move_in_dot([(X,A,Y)|Z]):-edge_in_dot(X,A,Y), move_in_dot(Z).
%
edge_in_dot(X,A,Y):-
	format("\"~w\" -> \"~w\" [label = \"~w\"];~n",
		   [X,Y,A]).
