:- module(test_trs,[]).

term_expansion --> pac:expand_pac.

:- use_module(misc(misc)).
:- use_module(pac('expand-pac')).

% ?- use_module(test('test-trs')), module(test_trs).
% ?- boole((f+f+t+f+f), X).
% ?- boole(-(t+f), X).
% ?- boole(-(t*t*t), X).
% ?- boole(-(t*t*f), X).

boole --> trs([t * X   = X,
				f * X  = f,
				t + X  = t,
				f + X  = X,
				- t    = f,
				- f    = t,
				X * Y  = X0 *Y	:- X = X0,
			    X * Y  = X * Y0	:- Y = Y0,
  			  	X + Y  = X0 + Y	:- X = X0,
   			  	X + Y  = X + Y0	:- Y = Y0,
				- X    = - X0   :- X = X0
			]).

% ?- calc_boole((t*t), X).
% ?- calc_boole(-(t*t), X).
:- betrs(calc_boole).
	t * X  = X.
	f * _  = f.
	t + _  = t.
	f + X  = X.
	- t    = f.
	- f    = t.
	X * Y  = X0 *Y	:- X = X0.
	X * Y  = X * Y0	:- Y = Y0.
  	X + Y  = X0 + Y	:- X = X0.
  	X + Y  = X + Y0	:- Y = Y0.
	- X    = - X0   :- X = X0.
:- etrs.

% ?- slim_goal_in_block((true, true, true), X).
% ?- slim_goal_in_block((a:b:true, true, true), X).
:- betrs(slim_goal_in_block).
A = call(A)			:- var(A).
(A, B) = (A0, B)	:- A = A0.
(A, B) = (A, B0)	:- B = B0.
(A; B) = (A0; B)	:- A = A0.
(A; B) = (A; B0)	:- B = B0.
(A -> B) = (A0->B)  :- A = A0.
(A -> B) = (A->B0)  :- B = B0.
\+(A) =  \+(A0)	    :- A = A0.
M:A =  M:B		    :- A = B.
(true, A) = A.
(A, true) = A.
(false, _A) =  false.
(true;true) = true.
(A; false) =  A.
(false; A) =  A.
(false -> _A) = false.
(true -> A) =  A.
\+(false) = true.
\+(true) = false.
(X=Y) = true		:- X == Y.
((X=Y) = false		:- X \== Y, ground((X,Y))).
(X==Y) = true		:- X == Y.
((X==Y) = false		:- X \== Y, ground((X,Y))).
nonvar(X) = true	:- nonvar(X).
var(X) = false		:- nonvar(X).
fail = false.
[]:A = A.
_M:(M:A) = M:A.
_M:E =  E			:- reduce:prefix_cancellable(E).
M:E =  ME			:- reduce:propagate_prefix(M, E, ME).
X = Y				:- reduce:slim_call(X, Y).
:- etrs.

% ?- slim_goal_in_dcg((true, true), X).
% ?- slim_goal_in_dcg(call(f(a)), X).
% ?- slim_goal_in_dcg(call(f(a), b), X).
slim_goal_in_dcg --> trs([
A = call(A)		 :- var(A),
(A, B) = (A0, B)	 :- A = A0,
(A, B) = (A, B0)	 :- B = B0,
(A; B) = (A0; B)	 :- A = A0,
(A; B) = (A; B0)	 :- B = B0,
(A -> B) = (A0->B)	 :- A = A0,
(A -> B) = (A->B0)   :- B = B0,
\+(A) =  \+(A0)	     :- A = A0,
M:A =  M:B		     :- A = B,
(true, A) = A,
(A, true) = A,
(false, _) =  false,
(true;true) = true,
(A; false) =  A,
(false; A) =  A,
(false -> _) = false,
(true -> A) =  A,
\+(false) = true,
\+(true) = false,
(X=Y) = true		 :- X == Y,
((X=Y) = false		 :- X \== Y, ground((X,Y))),
(X==Y) = true	     :- X == Y,
((X==Y) = false		 :- X \== Y, ground((X,Y))),
nonvar(X) = true	 :- nonvar(X),
var(X) = false	     :- nonvar(X),
fail = false,
[]:A = A,
_:(M:A) = M:A,
_:E =  E			 :- reduce:prefix_cancellable(E),
( M:E =  ME			 :- reduce:propagate_prefix(M, E, ME), ((M:E) \== ME)),
(X = Y				 :- reduce:slim_goal(X, Y), X\==Y)
]).

% ?- listing(xxx).
% a(V) :- X= append(misc:set::pow([a,b]), misc:set::pow([1,2]+[2,4])),
% 		eval_term(X, V).

% b(V) :-eval_term(append(misc:set::pow([a,b]), misc:set::pow([1,2]+[2,4])), V).
